export declare namespace SetUtils {
    type ElementPresenceChecker = <Element extends Value, Value>(array: ReadonlyArray<Element>, value: Value) => boolean;
}
export declare namespace ObjectUtils {
    type KeyLister = <Object extends GenericObject, Key extends keyof Object>(object: Object) => ReadonlyArray<Key>;
    type ValLister = <Object extends GenericObject, Key extends keyof Object>(object: Object) => ReadonlyArray<Object[Key]>;
    interface GenericObject {
        [key: string]: any;
    }
}
export declare namespace FunctionUtils {
    type RecursiveReturn<Return, Args extends any[]> = Return | ((...args: Args) => RecursiveReturn<Return, Args>);
}
export declare type FindingResult<Value> = FindingResult.NotFound | FindingResult.Found<Value>;
export declare namespace FindingResult {
    interface NotFound {
        readonly found: false;
    }
    interface Found<Value> {
        readonly found: true;
        readonly value: Value;
    }
}
